<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_tableName'] =  'civicrm_payment_processor';
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_PaymentProcessor extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Payment Processor ID
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which Domain owns this payment processor.
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * Payment Processor Name.
     *
     * @var string
     */
    var $name;
    /**
     * Payment Processor Description.
     *
     * @var string
     */
    var $description;
    /**
     * Payment Processor Type.
     *
     * @var string
     */
    var $payment_processor_type;
    /**
     * Is this processor active?
     *
     * @var boolean
     */
    var $is_active;
    /**
     * Is this processor the default?
     *
     * @var boolean
     */
    var $is_default;
    /**
     * Is this processor for a test site?
     *
     * @var boolean
     */
    var $is_test;
    /**
     *
     * @var string
     */
    var $user_name;
    /**
     *
     * @var string
     */
    var $password;
    /**
     *
     * @var string
     */
    var $signature;
    /**
     *
     * @var string
     */
    var $url_site;
    /**
     *
     * @var string
     */
    var $url_recur;
    /**
     *
     * @var string
     */
    var $url_button;
    /**
     *
     * @var string
     */
    var $subject;
    /**
     *
     * @var string
     */
    var $class_name;
    /**
     * Billing Mode
     *
     * @var int unsigned
     */
    var $billing_mode;
    /**
     * Can process recurring contributions
     *
     * @var boolean
     */
    var $is_recur;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_payment_processor
     */
    function CRM_Core_DAO_PaymentProcessor() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'name' => array(
                    'name' => 'name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Payment Processor') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'description' => array(
                    'name' => 'description',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Description') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'payment_processor_type' => array(
                    'name' => 'payment_processor_type',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Payment Processor Type') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'is_default' => array(
                    'name' => 'is_default',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'is_test' => array(
                    'name' => 'is_test',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'user_name' => array(
                    'name' => 'user_name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('User Name') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'password' => array(
                    'name' => 'password',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Password') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'signature' => array(
                    'name' => 'signature',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Signature') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_site' => array(
                    'name' => 'url_site',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Site URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_recur' => array(
                    'name' => 'url_recur',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Recurring Payments URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_button' => array(
                    'name' => 'url_button',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Button URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'subject' => array(
                    'name' => 'subject',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Subject') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'class_name' => array(
                    'name' => 'class_name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Suffix for PHP clas name implementation') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'billing_mode' => array(
                    'name' => 'billing_mode',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Billing Mode') ,
                    'required' => true,
                ) ,
                'is_recur' => array(
                    'name' => 'is_recur',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import'] = array();
            $fields = &CRM_Core_DAO_PaymentProcessor::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import']['payment_processor'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export'] = array();
            $fields = &CRM_Core_DAO_PaymentProcessor::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export']['payment_processor'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSOR']['_export'];
    }
}
?>