<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_tableName'] =  'civicrm_dedupe_rule_group';
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_fields'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_links'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_log'] =  false;
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['enums'] =  array(
            'contact_type',
        );
$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['translations'] =  null;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Dedupe_DAO_RuleGroup extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Unique dedupe rule group id
     *
     * @var int unsigned
     */
    var $id;
    /**
     * The id of the domain this rule group belongs to
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * The type of contacts this group applies to
     *
     * @var enum('Individual', 'Organization', 'Household')
     */
    var $contact_type;
    /**
     * The weight threshold the sum of the rule weights has to cross to consider two contacts the same
     *
     * @var int
     */
    var $threshold;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_dedupe_rule_group
     */
    function CRM_Dedupe_DAO_RuleGroup() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_links'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_fields'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'contact_type' => array(
                    'name' => 'contact_type',
                    'type' => CRM_UTILS_TYPE_T_ENUM,
                    'title' => ts('Contact Type') ,
                ) ,
                'threshold' => array(
                    'name' => 'threshold',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Threshold') ,
                    'required' => true,
                ) ,
            );
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import'] = array();
            $fields = &CRM_Dedupe_DAO_RuleGroup::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import']['dedupe_rule_group'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export'] = array();
            $fields = &CRM_Dedupe_DAO_RuleGroup::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export']['dedupe_rule_group'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['_export'];
    }
    /**
     * returns an array containing the enum fields of the civicrm_dedupe_rule_group table
     *
     * @return array (reference)  the array of enum fields
     */
     function &getEnums() 
    {
        
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['enums'];
    }
    /**
     * returns a ts()-translated enum value for display purposes
     *
     * @param string $field  the enum field in question
     * @param string $value  the enum value up for translation
     *
     * @return string  the display value of the enum
     */
     function tsEnum($field, $value) 
    {
        
        if (!$GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['translations']) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['translations'] = array(
                'contact_type' => array(
                    'Individual' => ts('Individual') ,
                    'Organization' => ts('Organization') ,
                    'Household' => ts('Household') ,
                ) ,
            );
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULEGROUP']['translations'][$field][$value];
    }
    /**
     * adds $value['foo_display'] for each $value['foo'] enum from civicrm_dedupe_rule_group
     *
     * @param array $values (reference)  the array up for enhancing
     * @return void
     */
     function addDisplayEnums(&$values) 
    {
        $enumFields = &CRM_Dedupe_DAO_RuleGroup::getEnums();
        foreach($enumFields as $enum) {
            if (isset($values[$enum])) {
                $values[$enum.'_display'] = CRM_Dedupe_DAO_RuleGroup::tsEnum($enum, $values[$enum]);
            }
        }
    }
}
?>